; Oh-la-la/theme.jl

(let*
    ((font (get-font
	    "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1"))
     (font-colors (list "grey40" "black"))

     (title-width
      (lambda (w)
	(+ 20 (text-width (window-name w) font))))

     (update-title-width
      (lambda (w)
	(if (eq (window-get w 'current-frame-style) 'Oh-la-la)
	    (rebuild-frame w))))

     (title-left-images (list (make-image "title-left-inactive.png")
			      (make-image "title-left-active.png")))
     (title-middle-images (list (make-image "title-middle-inactive.png")
				(make-image "title-middle-active.png")))
     (title-right-images (list (make-image "title-right-inactive.png")
			       (make-image "title-right-active.png")))

     (menu-image (make-image "menu.png"))

     (win-icon
      (lambda (w)
	(let ((icon (window-icon-image w)))
	  (if icon icon menu-image))))

     (iconify-images (list (make-image "iconify-inactive.png")
			   (make-image "iconify-active.png")))
     (maximize-images (list (make-image "maximize-inactive.png")
			    (make-image "maximize-active.png")))
     (close-images (list (make-image "close-inactive.png")
			 (make-image "close-active.png")))

     (girl-photos (list (make-image "girl-inactive.png")
			(make-image "girl-active.png")))
     (girl-small-photos (list (make-image "girl-small-inactive.png")
			      (make-image "girl-small-active.png")))

     (top-image (make-image "top-bar.png"))
     (top-right-image (make-image "top-right.png"))
     (right-image (make-image "right-bar.png"))
     (bottom-right-image (make-image "bottom-right.png"))
     (bottom-image (make-image "bottom-bar.png"))
     (bottom-left-image (make-image "bottom-left.png"))
     (left-image (make-image "left-bar.png"))
     (top-left-image (make-image "top-left.png"))


     (border
      `(((background . ,top-image)
	 (top-edge . -5)
	 (left-edge . 0)
	 (right-edge . 0)
	 (class . top-border))
	((background . ,top-right-image)
	 (right-edge . -5)
	 (top-edge . -5)
	 (class . top-right-corner))

	((background . ,right-image)
	 (right-edge . -5)
	 (top-edge . 0)
	 (bottom-edge . 0)
	 (class . right-border))
	((background . ,bottom-right-image)
	 (right-edge . -5)
	 (bottom-edge . -5)
	 (class . bottom-right-corner))

	((background . ,bottom-image)
	 (left-edge . 0)
	 (right-edge . 0)
	 (bottom-edge . -5)
	 (class . bottom-border))
	((background . ,bottom-left-image)
	 (left-edge . -5)
	 (bottom-edge . -5)
	 (class . bottom-left-corner))

	((background . ,left-image)
	 (left-edge . -5)
	 (top-edge . 0)
	 (bottom-edge . 0)
	 (class . left-border))
	((background . ,top-left-image)
	 (left-edge . -5)
	 (top-edge . -5)
	 (class . top-left-corner))))


     (title-maker
      (lambda (offset photo-offset photos)
	`(((background . ,title-left-images)
	   (left-edge . ,(lambda (w) (- (+ (car (window-dimensions w))
					   offset)
					(title-width w)
					-60)))
	   (bottom-edge . -26)
	   (class . title))

	  ((background . ,title-middle-images)
	   (foreground . ,font-colors)
	   (font . ,font)
	   (text . ,(lambda (w) (concat (window-name w) "        ")))
	   (left-edge . ,(lambda (w) (- (+ (car (window-dimensions w))
					   offset)
					(title-width w)
					-70)))
	   (right-edge . ,(+ offset 10))
	   (bottom-edge . -26)
	   (x-justify . center)
	   (y-justify . center)
	   (class . title))

	  ((background . ,title-right-images)
	   (right-edge . ,offset)
	   (bottom-edge . -26)
	   (class . title))

	  ((background . ,win-icon)
	   (left-edge . ,(lambda (w) (- (+ (car (window-dimensions w))
					   offset)
					(title-width w)
					-65)))
	   (bottom-edge . -23)
	   (width . 16)
	   (height . 16)
	   (class . menu-button))

	  ((background . ,iconify-images)
	   (right-edge . ,(+ offset 50))
	   (bottom-edge . -18)
	   (class . iconify-button))

	  ((background . ,maximize-images)
	   (right-edge . ,(+ offset 28))
	   (bottom-edge . -22)
	   (class . maximize-button))

	  ((background . ,close-images)
	   (right-edge . ,(+ offset 5))
	   (bottom-edge . -23)
	   (class . close-button))

	  ((background . ,photos)
	   (right-edge . ,photo-offset)
	   (top-edge . ,(lambda (w) (- (cdr (window-dimensions w))
				       (cdr (image-dimensions (car photos)))
				       -6)))
	   (cursor . heart)
	   (bottom-edge . -4)
	   (below-client . t)
	   (class . title)))))


     (title (title-maker -75 -130 girl-photos))


     (frame `(,@title ,@border))


     (transient-title (title-maker -75 -80 girl-small-photos))


     (transient-frame `(,@transient-title ,@border)))


  (add-frame-style
   'Oh-la-la
   (lambda (w type)
     (case type
       ((default) frame)
       ((shaded) title)
       ((shaped) title)
       ((transient) transient-frame)
       ((shaped-transient) transient-title))))

  (call-after-property-changed 'WM_NAME update-title-width))